# File: ExamFolder.py
# 
# Copyright (c) 2006 by eduplone Open Source Business Network EEIG, contributed
# by FH-Aargau, Switzerland
# Generator: ArchGenXML Version 1.4.0-RC1 
#            http://plone.org/products/archgenxml
#
# GNU General Public Licence (GPL)
# 
# This program is free software; you can redistribute it and/or modify it under
# the terms of the GNU General Public License as published by the Free Software
# Foundation; either version 2 of the License, or (at your option) any later
# version.
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
# FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
# details.
# You should have received a copy of the GNU General Public License along with
# this program; if not, write to the Free Software Foundation, Inc., 59 Temple
# Place, Suite 330, Boston, MA  02111-1307  USA
#
__author__  = '''Nils Haagen <nhaagen@philter.de>, Jens Klein <jens.klein@jensquadrat.com>'''
__docformat__ = 'plaintext'


from AccessControl import ClassSecurityInfo
from Products.Archetypes.atapi import *
from Products.EduploneExam.interfaces.IExamContext import IExamContext


from Products.EduploneExam.config import *
##code-section module-header #fill in your manual code here

from Products.Archetypes.Storage import AttributeStorage

from Products.CMFCore.utils import getToolByName
from registry import getQuestionTypes, getAdditionalTypes
from Products.EduploneExam.userresponses.SimpleResponse import SimpleResponse
from AccessControl import getSecurityManager, ClassSecurityInfo

import time
##/code-section module-header

schema=Schema((
    BooleanField('param_ShowScore',
        default="True",
        widget=BooleanWidget(
            label='Param_showscore',
            label_msgid='EduploneExam_label_param_ShowScore',
            description_msgid='EduploneExam_help_param_ShowScore',
            i18n_domain='EduploneExam',
        )
    ),

    BooleanField('param_showFinalScore',
        default="True",
        widget=BooleanWidget(
            label='Param_showfinalscore',
            label_msgid='EduploneExam_label_param_showFinalScore',
            description_msgid='EduploneExam_help_param_showFinalScore',
            i18n_domain='EduploneExam',
        )
    ),

    IntegerField('param_BatchSize',
        default="1",
        widget=IntegerWidget(
            label='Param_batchsize',
            label_msgid='EduploneExam_label_param_BatchSize',
            description_msgid='EduploneExam_help_param_BatchSize',
            i18n_domain='EduploneExam',
        )
    ),

    BooleanField('param_randomizeAnswers',
        default="True",
        widget=BooleanWidget(
            label='Param_randomizeanswers',
            label_msgid='EduploneExam_label_param_randomizeAnswers',
            description_msgid='EduploneExam_help_param_randomizeAnswers',
            i18n_domain='EduploneExam',
        )
    ),

    StringField('param_FinalPage',
        default="exam_finished",
        widget=StringWidget(
            label='Param_finalpage',
            label_msgid='EduploneExam_label_param_FinalPage',
            description_msgid='EduploneExam_help_param_FinalPage',
            i18n_domain='EduploneExam',
        ),
        schemata="settings"
    ),

    StringField('param_storageMethod',
        default="Session",
        widget=SelectionWidget
        (
            label='Param_storagemethod',
            label_msgid='EduploneExam_label_param_storageMethod',
            description_msgid='EduploneExam_help_param_storageMethod',
            i18n_domain='EduploneExam',
        ),
        schemata="settings",
        vocabulary=['Session','MemberFolder','eXamFolder']
    ),

),
)


##code-section after-local-schema #fill in your manual code here
##/code-section after-local-schema

ExamFolder_schema = BaseSchema + \
    schema

##code-section after-schema #fill in your manual code here
##/code-section after-schema

class ExamFolder(OrderedBaseFolder):
    security = ClassSecurityInfo()
    __implements__ = (getattr(OrderedBaseFolder,'__implements__',()),) + (IExamContext,)


    # This name appears in the 'add' box
    archetype_name             = 'ExamFolder'

    meta_type                  = 'ExamFolder'
    portal_type                = 'ExamFolder'
    allowed_content_types      = []
    filter_content_types       = 0
    global_allow               = 1
    allow_discussion           = 0
    content_icon               = 'icon_folder_red.png'
    immediate_view             = 'base_view'
    default_view               = 'base_view'
    suppl_views                = ()
    typeDescription            = "ExamFolder"
    typeDescMsgId              = 'description_edit_examfolder'

    actions =  (


       {'action':      "string:$object_url/exam_view",
        'category':    "object",
        'id':          'view',
        'name':        'View',
        'permissions': ("View",),
        'condition'  : 'python:1'
       },


       {'action':      "string:$object_url/exam_controlpanel",
        'category':    "object",
        'id':          'results',
        'name':        'Control Panel',
        'permissions': ("View",),
        'condition'  : 'python:1'
       },


       {'action':      "string:$object_url/folder_localrole_form",
        'category':    "object",
        'id':          'local_roles',
        'name':        'Sharing',
        'permissions': ("View",),
        'condition'  : 'python:1'
       },


    )

    schema = ExamFolder_schema

    ##code-section class-header #fill in your manual code here
    ##/code-section class-header


    #Methods

    security.declarePublic('allowedContentTypes')
    def allowedContentTypes(self):
        """ use own registry to recognize allowed tpyes """
        tt = getToolByName(self,'portal_types')
        qtypes = getQuestionTypes()
        allowed = [tt[tn] for tn in \
                    [qtypes[key].meta_type \
                     for key in qtypes]\
                  ]
        #AdditionalTypes from Registry:          
        atypes = getAdditionalTypes()                  
        for key in atypes:
            allowed.append(tt[atypes[key].meta_type])

        return allowed



    security.declarePublic('invokeFactory')
    def invokeFactory( self, type_name, id, RESPONSE=None, *args, **kw):
        """ Invokes the portal_types tool """
        try:
            return OrderedBaseFolder.invokeFactory(self, type_name, id, RESPONSE=None, *args, **kw)
        except:
            self._updateRegisteredTypes()
            return OrderedBaseFolder.invokeFactory(self, type_name, id, RESPONSE=None, *args, **kw)


    #methods from Interface IExamContext

    security.declarePublic('deliverResponse')
    def deliverResponse(self, question, create=False, forUser='-1'):
        '''
        Returns an SimpleResponse object.
        '''
        #-->storageMethod could be a module, mmh?
        storageMethod=self.getParam_storageMethod()
        q=question.UID()
        someId='someId' #generate?
        
        #filling userlist
        if storageMethod is not 'Session':
            if forUser == '-1':
                u=getSecurityManager().getUser().getId()
            else:
                u=forUser
                
            AttrS=AttributeStorage()
            attrName='_eXamUserList'
            if hasattr(self, attrName):
                uList=AttrS.get(attrName, self)
            else:
                uList=[]
            
            if u not in uList:
                uList.append(u)
                
            AttrS.set(attrName, self, uList)                

                
        #---------------------------------
        if storageMethod=='Session':
            session = self.session_data_manager.getSessionData(create=create)
            if session is not None:
                userresponse=session.get(q, SimpleResponse(someId))
                session.set(q, userresponse)
                return userresponse
            elif not create:
                return SimpleResponse(someId)
            else:
                return None

        #---------------------------------
        if storageMethod=='MemberFolder':
            
            if u is None: 
                raise Unauthorized, 'SecurityManager could not get your username. Are you logged in?'
    
            mfolder=getToolByName(self, 'portal_membership').getHomeFolder(u)
            if not 'eduploneExams' in mfolder.objectIds():
                mfolder.invokeFactory('Folder', 'eduploneExams')
                mfolder.eduploneExams.setTitle('eduplone Exam Answers')
            
            if self.UID() not in mfolder.eduploneExams.objectIds():
                mfolder.eduploneExams.invokeFactory('Folder', self.UID())
                mfolder.eduploneExams[self.UID()].setTitle('Answers for %s' % self.Title())
            
            examRFolder=mfolder.eduploneExams[self.UID()]
                
            if q not in examRFolder.objectIds():
                examRFolder.invokeFactory('SimpleResponse', q)
                
            return examRFolder[q]
        
        #---------------------------------
        if storageMethod=='eXamFolder':
            
            if not u: #if anonymous, use session-key (anon storage for statistics, etc, )
                try:
                    u=str(self.session_data_manager.getSessionData(create=create).getId())
                except:
                    u='FIXME'
            
            attrName='_eXamAnswer_%s' % u

            if hasattr(self, attrName):
                uAnswers=AttrS.get(attrName, self)
            else:
                uAnswers={}

            if q not in uAnswers.keys():
                uAnswers[q]=SimpleResponse(someId)

            return uAnswers[q]


    #manually created methods

    security.declareProtected('VIEW_RESULTS', 'getAllResults')
    def getAllResults(self):
        """ 
        """
        ret={}
        for u in self.listUsers():
            ret[u]=self.sumResultsForUser(u)
            
        return ret
        

    def sumResultsForUser(self, user):
        """ 
        """
        score=0
        for q in self.objectValues(self.getRegisteredQuestionTypes()):
            score=score + self.deliverResponse(q, False, user).getRelevantScore()
            
        return score
        

    security.declareProtected('VIEW_RESULTS', 'getFinishTime')
    def getFinishTime(self, forUser, format="%Y-%m-%d %H:%M:%S"):
        """ Returns finish time in a formatted output (use None for UNIX timestamp).
            Returns False if user didn't finish yet. """
        AttrS = AttributeStorage()
        attrName = "_eXamFinishedUsers"
        
        if not hasattr(self, attrName):
            AttrS.set(attrName, self, {})
            
        uList = AttrS.get(attrName, self)
        if uList.has_key(forUser):
            return time.strftime(format, time.gmtime(uList[forUser]))
        else:
            return False


    def folder_contents(self, REQUEST=None):
        """ """
        return self.exam_folder_contents()


    def overrideScore(self, request):
        """ """
        ret=[]
        user=request.get('forUser')
        for item in request.keys():
            if item.startswith('Override'):
                iSplit=item.split('##')
                sr=SimpleResponse('temp')
                question=sr._lookupUID(iSplit[1], self)    
                response=self.deliverResponse(question, create=False, forUser=user)

                v=request.get(item)
                eval("response.set%s(v)" % iSplit[0])
                

    def _updateRegisteredTypes(self):
        """ updates own fti based on registered containers """
        tt = getToolByName(self,'portal_types')
        ti = tt[self.meta_type]
        qtypes = getQuestionTypes()
        atypes = getAdditionalTypes()
        allowedmetatypes = [qtypes[key].meta_type for key in qtypes]
        for key in atypes:
            allowedmetatypes.append(atypes[key].meta_type)
        ti.allowed_content_types=tuple(allowedmetatypes)


    #security.declareProtected('delUsersFromList', SEC)
    def delUsersFromList(self, users=[]):
        """ removes users from eXam user lists, but not the results
            from the user's home directory (if MemberFolder storage is selected)
        """
        AttrS = AttributeStorage()
        attrName = "_eXamUserList"
        
        uList = AttrS.get(attrName, self)
        for user in users:
            if user in uList:
                uList.remove(user)
        AttrS.set(attrName, self, uList)
        
        attrName = "_eXamFinishedUsers"
        uList = AttrS.get(attrName, self)
        for user in uList.keys():
            if user in users:
                del uList[user]
        AttrS.set(attrName, self, uList)
        

    def setFinished(self):
        """ Sets finished flag for current user only (security reasons!) """
        AttrS = AttributeStorage()
        attrName = "_eXamFinishedUsers"
        u = getSecurityManager().getUser().getId()
        
        if not hasattr(self, attrName):
            AttrS.set(attrName, self, {})
            
        uList = AttrS.get(attrName, self)
        uList.update({u: time.time()})
        AttrS.set(attrName, self, uList)


    def storeResponseAttr(self, q, rObj):
        """ use Attribute with prefix "_eXamAnswer_" followed by userId
            and stash it away at the eXamFolder"""
            
        AttrS=AttributeStorage()
        u=getSecurityManager().getUser().getId()
        
        if not u: #if anonymous, use session-key (for statistics, etc, )
            u=str(self.session_data_manager.getSessionData(create=1).getId())
            
        attrName='_eXamAnswer_%s' % u

        if hasattr(self, attrName):
            uAnswers=AttrS.get(attrName, self)
        else:
            uAnswers={}
        
        uAnswers[q]=rObj
        
        AttrS.set(attrName, self, uAnswers)


    security.declareProtected('VIEW_RESULTS', 'getSecuredContentValues') 
    def getSecuredContentValues(self):
        """ will only return content values if user has VIEW_RESULTS permissions """
        return self.contentValues(self.getRegisteredQuestionTypes().keys())
        

    security.declareProtected('VIEW_RESULTS', 'exportResultsCSV') 
    def exportResultsCSV(self, REQUEST=None, RESPONSE=None):
        """ """
        filename='ergbenisse.csv'
        
        #get content together
        questions=self.objectValues(self.getRegisteredQuestionTypes())
        user=self.listUsers()
         
        ret='"name","total"'
        for q in questions:
            ret='%s,"%s"' % (ret, q.Title()) 
        
        for user in self.listUsers():
            ret='%s\n"%s"' % (ret, user)
            ret='%s,"%s"' % (ret, str(self.sumResultsForUser(user)).replace('.',','))
            
            for q in questions:
                r=self.deliverResponse(q, False, user)
                cleanScore=str(r.getRelevantScore()).replace('.',',')
                ret='%s,"%s"' % (ret,cleanScore)
        
        #crude; but - what the hey :)
        f=REQUEST.RESPONSE
        f.setHeader("Content-Type","text/cvs")
        f.setHeader("Content-disposition","attachment; filename=%s" % filename)
        f.write(ret)
        
        return f
        

    def getRegisteredQuestionTypes(self):
        """ used by exam_view; skips additional_types"""
        return getQuestionTypes()


    def hasFinished(self):
        """ Returns either True or False whether current user has finished """
        AttrS = AttributeStorage()
        attrName = "_eXamFinishedUsers"
        u = getSecurityManager().getUser().getId()
        
        if not hasattr(self, attrName):
            AttrS.set(attrName, self, {})
            
        uList = AttrS.get(attrName, self)
        #return False
        return u in uList.keys()
        

    def showEditableBorder(self, **kwargs):
        """
        """
        pmt=getToolByName(self, 'portal_membership')
        return pmt.checkPermission("Modify Portal Content", self)
        

    def getAnswerAmount(self):
        """ Returns the amount of answers inside current ExamFolder,
            used for controller page templates """
        return len(self.contentValues())


    def getMaxScore(self):
        """ returns maximum possible score """
        maxScore=0
        for q in self.objectValues(self.getRegisteredQuestionTypes()):
            maxScore += q.getMaxScore()
            
        return maxScore
        

    def listUsers(self):
        """ """
        AttrS = AttributeStorage()
        if hasattr(self, "_eXamUserList"):
            userlist = AttrS.get("_eXamUserList", self)
            # Filter None-type objects
            return [ user for user in userlist if user is not None ]
        else:
            return []



registerType(ExamFolder,PROJECTNAME)
# end of class ExamFolder

##code-section module-footer #fill in your manual code here
##/code-section module-footer



