# File: BlindGapAnswer.py
# 
# Copyright (c) 2006 by eduplone Open Source Business Network EEIG, contributed
# by FH-Aargau, Switzerland
# Generator: ArchGenXML Version 1.4.0-RC1 
#            http://plone.org/products/archgenxml
#
# GNU General Public Licence (GPL)
# 
# This program is free software; you can redistribute it and/or modify it under
# the terms of the GNU General Public License as published by the Free Software
# Foundation; either version 2 of the License, or (at your option) any later
# version.
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
# FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
# details.
# You should have received a copy of the GNU General Public License along with
# this program; if not, write to the Free Software Foundation, Inc., 59 Temple
# Place, Suite 330, Boston, MA  02111-1307  USA
#
__author__  = '''Nils Haagen <nhaagen@philter.de>, Jens Klein <jens.klein@jensquadrat.com>'''
__docformat__ = 'plaintext'


from AccessControl import ClassSecurityInfo
from Products.Archetypes.atapi import *
from TextLineAnswer import TextLineAnswer


# additional imports from tagged value 'import'
from Products.EduploneExam.registry import registerAnswerType

from Products.EduploneExam.config import *
##code-section module-header #fill in your manual code here
##/code-section module-header

schema=Schema((
),
)


##code-section after-local-schema #fill in your manual code here
##/code-section after-local-schema

BlindGapAnswer_schema = BaseSchema + \
    getattr(TextLineAnswer,'schema',Schema(())) + \
    schema

##code-section after-schema #fill in your manual code here
##/code-section after-schema

class BlindGapAnswer(TextLineAnswer):
    security = ClassSecurityInfo()
    __implements__ = (getattr(TextLineAnswer,'__implements__',()),)


    # This name appears in the 'add' box
    archetype_name             = 'BlindGapAnswer'

    meta_type                  = 'BlindGapAnswer'
    portal_type                = 'BlindGapAnswer'
    allowed_content_types      = [] + list(getattr(TextLineAnswer, 'allowed_content_types', []))
    filter_content_types       = 0
    global_allow               = 0
    allow_discussion           = 0
    #content_icon               = 'BlindGapAnswer.gif'
    immediate_view             = 'base_view'
    default_view               = 'base_view'
    suppl_views                = ()
    typeDescription            = "BlindGapAnswer"
    typeDescMsgId              = 'description_edit_blindgapanswer'

    schema = BlindGapAnswer_schema

    ##code-section class-header #fill in your manual code here
    actions=  (
        
       {'action':      '''string:$object_url/exam_fillgap_edit''',
        'category':    '''object''',
        'id':          'edit',
        'name':        'exam_fillgap_edit',
        'permissions': ('''Edit''',),
        'condition'  : 'python:1'},
  
          )
    created = False
    ##/code-section class-header


    #Methods
    #manually created methods

    def processValue(self, value=''):
        """ """
        # Check if answer is case sensitive
        if value and self.getCaseSensitive():
            if value and value in self.getCorrect():
                return True
            else:
                return False

        else:
            for correctAnswer in self.getCorrect():
                if value and correctAnswer.lower() == value.lower():
                    return True
            return False


    def manage_beforeDelete(self, item, container):
        """ """
        TextLineAnswer.manage_beforeDelete(self, item, container)
        basetext_new = []
        match = "<id='%s'>" % self.getId()
        for i in self.aq_parent.getBasetextAsList():
            if i == match:
                basetext_new.append(self.getCorrect()[0])
            else:
                basetext_new.append(i)
        self.aq_parent.setBasetext(" ".join(basetext_new))
        

    def setCreated(self, value):
        """ Neccessary to avoid Zopes restricted python guard """
        if value in [True, False]:
            self.created = value
	         

    def getCreated(self):
        """ """
        return self.created
        


registerType(BlindGapAnswer,PROJECTNAME)
# end of class BlindGapAnswer

##code-section module-footer #fill in your manual code here
registerAnswerType(BlindGapAnswer)
##/code-section module-footer



