# File: BooleanAnswer.py
# 
# Copyright (c) 2006 by eduplone Open Source Business Network EEIG, contributed
# by FH-Aargau, Switzerland
# Generator: ArchGenXML Version 1.4.0-RC1 
#            http://plone.org/products/archgenxml
#
# GNU General Public Licence (GPL)
# 
# This program is free software; you can redistribute it and/or modify it under
# the terms of the GNU General Public License as published by the Free Software
# Foundation; either version 2 of the License, or (at your option) any later
# version.
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
# FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
# details.
# You should have received a copy of the GNU General Public License along with
# this program; if not, write to the Free Software Foundation, Inc., 59 Temple
# Place, Suite 330, Boston, MA  02111-1307  USA
#
__author__  = '''Nils Haagen <nhaagen@philter.de>, Jens Klein <jens.klein@jensquadrat.com>'''
__docformat__ = 'plaintext'


from AccessControl import ClassSecurityInfo
from Products.Archetypes.atapi import *
from BaseAnswer import BaseAnswer


# additional imports from tagged value 'import'
from Products.EduploneExam.registry import registerAnswerType

from Products.EduploneExam.config import *
##code-section module-header #fill in your manual code here
from types import StringTypes

##/code-section module-header

schema=Schema((
    TextField('challenge',
        widget=TextAreaWidget(
            label='Challenge',
            label_msgid='EduploneExam_label_challenge',
            description_msgid='EduploneExam_help_challenge',
            i18n_domain='EduploneExam',
        )
    ),

    ImageField('picture',
        widget=ImageWidget(
            label='Picture',
            label_msgid='EduploneExam_label_picture',
            description_msgid='EduploneExam_help_picture',
            i18n_domain='EduploneExam',
        ),
        storage=AttributeStorage()
    ),

    BooleanField('correct',
        widget=BooleanWidget(
            label='Correct',
            label_msgid='EduploneExam_label_correct',
            description_msgid='EduploneExam_help_correct',
            i18n_domain='EduploneExam',
        )
    ),

    StringField('answer_explanation',
        widget=StringWidget(
            label='Answer_explanation',
            label_msgid='EduploneExam_label_answer_explanation',
            description_msgid='EduploneExam_help_answer_explanation',
            i18n_domain='EduploneExam',
        )
    ),

),
)


##code-section after-local-schema #fill in your manual code here
##/code-section after-local-schema

BooleanAnswer_schema = getattr(BaseAnswer,'schema',Schema(())) + \
    schema

##code-section after-schema #fill in your manual code here
##/code-section after-schema

class BooleanAnswer(BaseAnswer,BaseContent):
    """
    an abstract class representing a template for all boolean answer
    types
    """
    security = ClassSecurityInfo()
    __implements__ = (getattr(BaseAnswer,'__implements__',()),) + (getattr(BaseContent,'__implements__',()),)


    allowed_content_types      = [] + list(getattr(BaseAnswer, 'allowed_content_types', []))
    schema = BooleanAnswer_schema

    ##code-section class-header #fill in your manual code here
    ##/code-section class-header


    #Methods
    #manually created methods

    security.declarePublic('processValue')
    def processValue(self, value=None):
        '''

        '''
        if type(value) in StringTypes and value.lower() in ['0', 'false']:
            value=False
        if type(value) in StringTypes and value.lower() in ['on', 'true']:
            value=True

        if value:
            value=True
        else:
            value=False

        return self.getCorrect()==value


    security.declarePublic('Title')
    def Title(self):
        '''
        returns id as title
        '''

        return self.getId()


# end of class BooleanAnswer

##code-section module-footer #fill in your manual code here
##/code-section module-footer



