# File: ChoiceGapAnswer.py
# 
# Copyright (c) 2006 by eduplone Open Source Business Network EEIG, contributed
# by FH-Aargau, Switzerland
# Generator: ArchGenXML Version 1.4.0-RC1 
#            http://plone.org/products/archgenxml
#
# GNU General Public Licence (GPL)
# 
# This program is free software; you can redistribute it and/or modify it under
# the terms of the GNU General Public License as published by the Free Software
# Foundation; either version 2 of the License, or (at your option) any later
# version.
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
# FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
# details.
# You should have received a copy of the GNU General Public License along with
# this program; if not, write to the Free Software Foundation, Inc., 59 Temple
# Place, Suite 330, Boston, MA  02111-1307  USA
#
__author__  = '''Nils Haagen <nhaagen@philter.de>, Jens Klein <jens.klein@jensquadrat.com>'''
__docformat__ = 'plaintext'


from AccessControl import ClassSecurityInfo
from Products.Archetypes.atapi import *
from BaseAnswer import BaseAnswer


# additional imports from tagged value 'import'
from Products.EduploneExam.registry import registerAnswerType

from Products.EduploneExam.config import *
##code-section module-header #fill in your manual code here
##/code-section module-header

schema=Schema((
    StringField('correct',
        widget=StringWidget(
            label="correct_textl",
            label_msgid="EduploneExam_label_correct_textl",
            description_msgid="EduploneExam_help_correct_textl",
            i18n_domain='EduploneExam',
        )
    ),

    LinesField('options',
        widget=LinesWidget(
            label='Options',
            label_msgid='EduploneExam_label_options',
            description_msgid='EduploneExam_help_options',
            i18n_domain='EduploneExam',
        )
    ),

),
)


##code-section after-local-schema #fill in your manual code here
##/code-section after-local-schema

ChoiceGapAnswer_schema = BaseSchema + \
    getattr(BaseAnswer,'schema',Schema(())) + \
    schema

##code-section after-schema #fill in your manual code here
##/code-section after-schema

class ChoiceGapAnswer(BaseAnswer,BaseContent):
    security = ClassSecurityInfo()
    __implements__ = (getattr(BaseAnswer,'__implements__',()),) + (getattr(BaseContent,'__implements__',()),)


    # This name appears in the 'add' box
    archetype_name             = 'ChoiceGapAnswer'

    meta_type                  = 'ChoiceGapAnswer'
    portal_type                = 'ChoiceGapAnswer'
    allowed_content_types      = [] + list(getattr(BaseAnswer, 'allowed_content_types', []))
    filter_content_types       = 0
    global_allow               = 0
    allow_discussion           = 0
    #content_icon               = 'ChoiceGapAnswer.gif'
    immediate_view             = 'base_view'
    default_view               = 'base_view'
    suppl_views                = ()
    typeDescription            = "ChoiceGapAnswer"
    typeDescMsgId              = 'description_edit_choicegapanswer'

    schema = ChoiceGapAnswer_schema

    ##code-section class-header #fill in your manual code here
    actions=  (
        
       {'action':      '''string:$object_url/exam_fillgap_edit''',
        'category':    '''object''',
        'id':          'edit',
        'name':        'exam_fillgap_edit',
        'permissions': ('''Edit''',),
        'condition'  : 'python:1'},
  
          )
    created = False
    ##/code-section class-header


    #Methods
    #manually created methods

    def getCleanOptions(self):
        ''' concatenates self.correct and self.options
            and sorts the list        
        '''
        cleanOptions=[]
        cleanOptions.append(self.getCorrect()) ##shouldn't correct be Lines, too?
        
        for o in self.getOptions():
            cleanOptions.append(o)
            
        cleanOptions.sort()
        
        return cleanOptions


    security.declarePublic('processValue')
    def processValue(self, value=''):
        '''
        
        '''
        if value and value == self.getCorrect():
            return True
        else:
            return False


    def manage_beforeDelete(self, item, container):
        """ """
        BaseAnswer.manage_beforeDelete(self, item, container)
        basetext_new = []
        match = "<id='%s'>" % self.getId()
        for i in self.aq_parent.getBasetextAsList():
            if i == match:
                basetext_new.append(self.getCorrect())
            else:
                basetext_new.append(i)
        self.aq_parent.setBasetext(" ".join(basetext_new))


    def setCreated(self, value):
        """ Neccessary to avoid Zopes restricted python guard """
        if value in [True, False]:
            self.created = value
	 

    def getCreated(self):
        """ """
        return self.created
        


registerType(ChoiceGapAnswer,PROJECTNAME)
# end of class ChoiceGapAnswer

##code-section module-footer #fill in your manual code here

registerAnswerType(ChoiceGapAnswer)

##/code-section module-footer



