# File: MatchingAnswer.py
# 
# Copyright (c) 2006 by eduplone Open Source Business Network EEIG, contributed
# by FH-Aargau, Switzerland
# Generator: ArchGenXML Version 1.4.0-RC1 
#            http://plone.org/products/archgenxml
#
# GNU General Public Licence (GPL)
# 
# This program is free software; you can redistribute it and/or modify it under
# the terms of the GNU General Public License as published by the Free Software
# Foundation; either version 2 of the License, or (at your option) any later
# version.
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
# FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
# details.
# You should have received a copy of the GNU General Public License along with
# this program; if not, write to the Free Software Foundation, Inc., 59 Temple
# Place, Suite 330, Boston, MA  02111-1307  USA
#
__author__  = '''Nils Haagen <nhaagen@philter.de>, Jens Klein <jens.klein@jensquadrat.com>'''
__docformat__ = 'plaintext'


from AccessControl import ClassSecurityInfo
from Products.Archetypes.atapi import *
from BaseAnswer import BaseAnswer


# additional imports from tagged value 'import'
from Products.EduploneExam.registry import registerAnswerType

from Products.EduploneExam.config import *
##code-section module-header #fill in your manual code here
##/code-section module-header

schema=Schema((
    StringField('challenge',
        widget=StringWidget(
            label="challenge_match",
            label_msgid="EduploneExam_label_challenge_match",
            description_msgid="EduploneExam_help_challenge_match",
            i18n_domain='EduploneExam',
        )
    ),

    StringField('correct',
        widget=StringWidget(
            label="correct_match",
            label_msgid="EduploneExam_label_correct_match",
            description_msgid="EduploneExam_help_correct_match",
            i18n_domain='EduploneExam',
        )
    ),

    ImageField('picture',
        widget=ImageWidget(
            label='Picture',
            label_msgid='EduploneExam_label_picture',
            description_msgid='EduploneExam_help_picture',
            i18n_domain='EduploneExam',
        ),
        storage=AttributeStorage()
    ),

),
)


##code-section after-local-schema #fill in your manual code here
##/code-section after-local-schema

MatchingAnswer_schema = BaseSchema + \
    getattr(BaseAnswer,'schema',Schema(())) + \
    schema

##code-section after-schema #fill in your manual code here
##/code-section after-schema

class MatchingAnswer(BaseAnswer,BaseContent):
    security = ClassSecurityInfo()
    __implements__ = (getattr(BaseAnswer,'__implements__',()),) + (getattr(BaseContent,'__implements__',()),)


    # This name appears in the 'add' box
    archetype_name             = 'MatchingAnswer'

    meta_type                  = 'MatchingAnswer'
    portal_type                = 'MatchingAnswer'
    allowed_content_types      = [] + list(getattr(BaseAnswer, 'allowed_content_types', []))
    filter_content_types       = 0
    global_allow               = 0
    allow_discussion           = 0
    #content_icon               = 'MatchingAnswer.gif'
    immediate_view             = 'base_view'
    default_view               = 'base_view'
    suppl_views                = ()
    typeDescription            = "MatchingAnswer"
    typeDescMsgId              = 'description_edit_matchinganswer'

    schema = MatchingAnswer_schema

    ##code-section class-header #fill in your manual code here
    ##/code-section class-header


    #Methods
    #manually created methods

    security.declarePublic('processValue')
    def processValue(self, value=''):
        '''
        
        '''
        if value and value == self.getCorrect():
            return True
        else:
            return False



registerType(MatchingAnswer,PROJECTNAME)
# end of class MatchingAnswer

##code-section module-footer #fill in your manual code here
registerAnswerType(MatchingAnswer)
##/code-section module-footer



