# File: MathAnswer.py
# 
# Copyright (c) 2006 by eduplone Open Source Business Network EEIG, contributed
# by FH-Aargau, Switzerland
# Generator: ArchGenXML Version 1.4.0-RC1 
#            http://plone.org/products/archgenxml
#
# GNU General Public Licence (GPL)
# 
# This program is free software; you can redistribute it and/or modify it under
# the terms of the GNU General Public License as published by the Free Software
# Foundation; either version 2 of the License, or (at your option) any later
# version.
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
# FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
# details.
# You should have received a copy of the GNU General Public License along with
# this program; if not, write to the Free Software Foundation, Inc., 59 Temple
# Place, Suite 330, Boston, MA  02111-1307  USA
#
__author__  = '''Nils Haagen <nhaagen@philter.de>, Jens Klein <jens.klein@jensquadrat.com>'''
__docformat__ = 'plaintext'


from AccessControl import ClassSecurityInfo
from Products.Archetypes.atapi import *
from BaseAnswer import BaseAnswer


# additional imports from tagged value 'import'
from Products.EduploneExam.registry import registerAnswerType

from Products.EduploneExam.config import *
##code-section module-header #fill in your manual code here
##/code-section module-header

schema=Schema((
    FloatField('correct',
        widget=DecimalWidget(
            label="correct_math",
            label_msgid="EduploneExam_label_correct_math",
            description_msgid="EduploneExam_help_correct_math",
            i18n_domain='EduploneExam',
        )
    ),

    FloatField('tolerance',
        default="0",
        widget=DecimalWidget(
            description="Enter the allowed absolute difference (+/-) to the correct value.",
            label='Tolerance',
            label_msgid='EduploneExam_label_tolerance',
            description_msgid='EduploneExam_help_tolerance',
            i18n_domain='EduploneExam',
        )
    ),

    StringField('answer_explanation',
        widget=StringWidget(
            label='Answer_explanation',
            label_msgid='EduploneExam_label_answer_explanation',
            description_msgid='EduploneExam_help_answer_explanation',
            i18n_domain='EduploneExam',
        )
    ),

),
)


##code-section after-local-schema #fill in your manual code here
##/code-section after-local-schema

MathAnswer_schema = BaseSchema + \
    getattr(BaseAnswer,'schema',Schema(())) + \
    schema

##code-section after-schema #fill in your manual code here
##/code-section after-schema

class MathAnswer(BaseAnswer,BaseContent):
    security = ClassSecurityInfo()
    __implements__ = (getattr(BaseAnswer,'__implements__',()),) + (getattr(BaseContent,'__implements__',()),)


    # This name appears in the 'add' box
    archetype_name             = 'MathAnswer'

    meta_type                  = 'MathAnswer'
    portal_type                = 'MathAnswer'
    allowed_content_types      = [] + list(getattr(BaseAnswer, 'allowed_content_types', []))
    filter_content_types       = 0
    global_allow               = 0
    allow_discussion           = 0
    #content_icon               = 'MathAnswer.gif'
    immediate_view             = 'base_view'
    default_view               = 'base_view'
    suppl_views                = ()
    typeDescription            = "MathAnswer"
    typeDescMsgId              = 'description_edit_mathanswer'

    schema = MathAnswer_schema

    ##code-section class-header #fill in your manual code here
    ##/code-section class-header


    #Methods
    #manually created methods

    security.declarePublic('processValue')
    def processValue(self, value=None):
        '''
        
        '''
        range = (self.getCorrect()-self.getTolerance(), self.getCorrect()+self.getTolerance())
        try:
            float(value)
        except:
            return False
         
        if value and float(value) and float(value) >= range[0] and float(value) <= range[1] :
            return True
        else:
            return False



registerType(MathAnswer,PROJECTNAME)
# end of class MathAnswer

##code-section module-footer #fill in your manual code here
registerAnswerType(MathAnswer)
##/code-section module-footer



