# File: BaseExamQuestion.py
# 
# Copyright (c) 2006 by eduplone Open Source Business Network EEIG, contributed
# by FH-Aargau, Switzerland
# Generator: ArchGenXML Version 1.4.0-RC1 
#            http://plone.org/products/archgenxml
#
# GNU General Public Licence (GPL)
# 
# This program is free software; you can redistribute it and/or modify it under
# the terms of the GNU General Public License as published by the Free Software
# Foundation; either version 2 of the License, or (at your option) any later
# version.
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
# FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
# details.
# You should have received a copy of the GNU General Public License along with
# this program; if not, write to the Free Software Foundation, Inc., 59 Temple
# Place, Suite 330, Boston, MA  02111-1307  USA
#
__author__  = '''Nils Haagen <nhaagen@philter.de>, Jens Klein <jens.klein@jensquadrat.com>'''
__docformat__ = 'plaintext'


from AccessControl import ClassSecurityInfo
from Products.Archetypes.atapi import *
from Products.EduploneExam.interfaces.IExamNotifier import IExamNotifier
from Products.EduploneExam.interfaces.IExamQuestion import IExamQuestion


# additional imports from tagged value 'import'
from Products.EduploneExam.registry import registerQuestionType

from Products.EduploneExam.config import *
##code-section module-header #fill in your manual code here
from Products.CMFCore.utils import getToolByName
from Products.Archetypes.config import UID_CATALOG
import random
from Products.ATContentTypes.lib.imagetransform import ATCTImageTransform
from Products.ATContentTypes.configuration import zconf
##/code-section module-header

schema=Schema((
    TextField('question',
        widget=RichWidget
        (
            label='Question',
            label_msgid='EduploneExam_label_question',
            description_msgid='EduploneExam_help_question',
            i18n_domain='EduploneExam',
        )
    ),

    TextField('instruction',
        widget=TextAreaWidget(
            label='Instruction',
            label_msgid='EduploneExam_label_instruction',
            description_msgid='EduploneExam_help_instruction',
            i18n_domain='EduploneExam',
        )
    ),

    IntegerField('maxScore',
        default="0",
        widget=IntegerWidget(
            label='Maxscore',
            label_msgid='EduploneExam_label_maxScore',
            description_msgid='EduploneExam_help_maxScore',
            i18n_domain='EduploneExam',
        )
    ),

    ImageField('picture',
        schemata="pictures",
        widget=ImageWidget(
            label='Picture',
            label_msgid='EduploneExam_label_picture',
            description_msgid='EduploneExam_help_picture',
            i18n_domain='EduploneExam',
        ),
        storage=AttributeStorage()
    ),

    ImageField('exemplar_picture',
        schemata="pictures",
        widget=ImageWidget(
            label='Exemplar_picture',
            label_msgid='EduploneExam_label_exemplar_picture',
            description_msgid='EduploneExam_help_exemplar_picture',
            i18n_domain='EduploneExam',
        ),
        storage=AttributeStorage()
    ),

),
)


##code-section after-local-schema #fill in your manual code here
##/code-section after-local-schema

BaseExamQuestion_schema = schema

##code-section after-schema #fill in your manual code here
##/code-section after-schema

class BaseExamQuestion(OrderedBaseFolder,ATCTImageTransform):
    security = ClassSecurityInfo()
    __implements__ = (getattr(OrderedBaseFolder,'__implements__',()),) + (IExamNotifier,IExamQuestion,)


    allowed_content_types      = []
    schema = BaseExamQuestion_schema

    ##code-section class-header #fill in your manual code here
    initial_view='question_view'
    default_view='question_view'

    actions =  (
      
       {'action':      "string:$object_url/exam_questionBaseview",
        'category':    "object",
        'id':          'view',
        'name':        'question_view',
        'permissions': ("View",),
        'condition'  : 'python:1'
       },
    )
    ##/code-section class-header


    #Methods
    #methods from Interface IExamNotifier

    security.declarePublic('registerNotifierOnView')
    def registerNotifierOnView(self,object):
        '''
        register an object
        '''



    security.declarePublic('registerNotifierAfterProcess')
    def registerNotifierAfterProcess(self,object):
        '''

        '''



    security.declarePublic('notifyOnView')
    def notifyOnView(self):
        '''

        '''



    security.declarePublic('notifyAfterProcess')
    def notifyAfterProcess(self):
        '''

        '''


    #methods from Interface IExamQuestion

    security.declarePublic('processResponse')
    def processResponse(self,REQUEST):
        '''
        gets a REQUEST and returns an ExamResponse object
        '''
        #creating/loading an allmost responseObject
        responseObj=self.deliverResponse(self, create=True)
        responseObj.setQuestion(self)
        return responseObj



    security.declarePublic('getQuestionType')
    def getQuestionType(self):
        '''
        '''
        return self.archetype_name



    security.declarePublic('hasAnswers')
    def hasAnswers(self):
        """ returns Boolean; 
            True, if there are subobjects,
            False, if there are None.
        """
        if self.objectIds().length > 0 :
            return True
        else :
            return False
        

    #manually created methods

    def randomContentValues(self, randomize=True):
        """ Randomize the order of the answers.
            The randomize parameter is neccessary because TAL language
            doesn't support multiple-line-statements. """
        randomizedValues = self.contentValues()
        if randomize in [True, False]:
            if randomize:
                random.shuffle(randomizedValues)
        return randomizedValues
        

    def folder_contents(self, REQUEST=None):
        """ """
        return self.exam_folder_contents()
    

    def getQuestionIntroduction(self, word_count=7):
    	""" """
    	question_list = self.getQuestion().split()
    	if len(question_list) <= word_count:
    		return self.getQuestion()
    	else:
    		return "%s..." % " ".join(question_list[0:word_count])
    		

    def _lookupUID(self, uid):
        tool = getToolByName(self, UID_CATALOG)
        brains = tool(UID=uid)
        for brain in brains:
            obj = brain.getObject()
            if obj is not None:
                return obj
        else:
            return None


# end of class BaseExamQuestion

##code-section module-footer #fill in your manual code here
##/code-section module-footer



