# File: MathQuestion.py
# 
# Copyright (c) 2006 by eduplone Open Source Business Network EEIG, contributed
# by FH-Aargau, Switzerland
# Generator: ArchGenXML Version 1.4.0-RC1 
#            http://plone.org/products/archgenxml
#
# GNU General Public Licence (GPL)
# 
# This program is free software; you can redistribute it and/or modify it under
# the terms of the GNU General Public License as published by the Free Software
# Foundation; either version 2 of the License, or (at your option) any later
# version.
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
# FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
# details.
# You should have received a copy of the GNU General Public License along with
# this program; if not, write to the Free Software Foundation, Inc., 59 Temple
# Place, Suite 330, Boston, MA  02111-1307  USA
#
__author__  = '''Nils Haagen <nhaagen@philter.de>, Jens Klein <jens.klein@jensquadrat.com>'''
__docformat__ = 'plaintext'


from AccessControl import ClassSecurityInfo
from Products.Archetypes.atapi import *
from BaseExamQuestion import BaseExamQuestion


# additional imports from tagged value 'import'
from Products.EduploneExam.registry import registerQuestionType

from Products.EduploneExam.config import *
##code-section module-header #fill in your manual code here
##/code-section module-header

schema=Schema((
),
)


##code-section after-local-schema #fill in your manual code here
##/code-section after-local-schema

MathQuestion_schema = BaseFolderSchema + \
    getattr(BaseExamQuestion,'schema',Schema(())) + \
    schema

##code-section after-schema #fill in your manual code here
##/code-section after-schema

class MathQuestion(BaseExamQuestion):
    security = ClassSecurityInfo()
    __implements__ = (getattr(BaseExamQuestion,'__implements__',()),)


    # This name appears in the 'add' box
    archetype_name             = 'MathQuestion'

    meta_type                  = 'MathQuestion'
    portal_type                = 'MathQuestion'
    allowed_content_types      = ['MathAnswer'] + list(getattr(BaseExamQuestion, 'allowed_content_types', []))
    filter_content_types       = 1
    global_allow               = 0
    allow_discussion           = 0
    content_icon               = 'icon_question_blue.png'
    immediate_view             = 'base_view'
    default_view               = 'base_view'
    suppl_views                = ()
    typeDescription            = "MathQuestion"
    typeDescMsgId              = 'description_edit_mathquestion'

    schema = MathQuestion_schema

    ##code-section class-header #fill in your manual code here
    ##/code-section class-header


    #Methods
    #manually created methods

    def processResponse(self, REQUEST):
        ''' 
        '''
        #get an responseObject from BaseExamQuestion
        #context and question are set
        responseObj=BaseExamQuestion.processResponse(self, REQUEST)
        
        kw={} #Dict
        possibleCorrect=0
        score=0
        answerObjects=self.objectValues(['MathAnswer'])
        
        sUID=self.UID() 
        kw[sUID]=REQUEST.get(sUID, '')
        
        #with a text/math-input, answers are not mandatory
        if len(answerObjects)>0:
            answerObject=answerObjects[0]
            possibleCorrect=1
            #process Answer (see, if correct)
            try: 
                if answerObject.processValue(kw[sUID]):
                    score=self.getMaxScore()
            except:
                score=0
        #fill in actual user-input as answer and set score
        responseObj.setResponseValues(**kw)
        responseObj.setScore(score)

        examFolder=self.aq_parent
        if examFolder.getParam_storageMethod()=='eXamFolder':
            examFolder.storeResponseAttr(self.UID(), responseObj)



registerType(MathQuestion,PROJECTNAME)
# end of class MathQuestion

##code-section module-footer #fill in your manual code here
registerQuestionType(MathQuestion)
##/code-section module-footer



