# File: TrueFalseQuestion.py
# 
# Copyright (c) 2006 by eduplone Open Source Business Network EEIG, contributed
# by FH-Aargau, Switzerland
# Generator: ArchGenXML Version 1.4.0-RC1 
#            http://plone.org/products/archgenxml
#
# GNU General Public Licence (GPL)
# 
# This program is free software; you can redistribute it and/or modify it under
# the terms of the GNU General Public License as published by the Free Software
# Foundation; either version 2 of the License, or (at your option) any later
# version.
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
# FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
# details.
# You should have received a copy of the GNU General Public License along with
# this program; if not, write to the Free Software Foundation, Inc., 59 Temple
# Place, Suite 330, Boston, MA  02111-1307  USA
#
__author__  = '''Nils Haagen <nhaagen@philter.de>, Jens Klein <jens.klein@jensquadrat.com>'''
__docformat__ = 'plaintext'


from AccessControl import ClassSecurityInfo
from Products.Archetypes.atapi import *
from BaseExamQuestion import BaseExamQuestion


# additional imports from tagged value 'import'
from Products.EduploneExam.registry import registerQuestionType

from Products.EduploneExam.config import *
##code-section module-header #fill in your manual code here
##/code-section module-header

schema=Schema((
    BooleanField('strict',
        widget=BooleanWidget(
            label='Strict',
            label_msgid='EduploneExam_label_strict',
            description_msgid='EduploneExam_help_strict',
            i18n_domain='EduploneExam',
        )
    ),

),
)


##code-section after-local-schema #fill in your manual code here
##/code-section after-local-schema

TrueFalseQuestion_schema = BaseFolderSchema + \
    getattr(BaseExamQuestion,'schema',Schema(())) + \
    schema

##code-section after-schema #fill in your manual code here
##/code-section after-schema

class TrueFalseQuestion(BaseExamQuestion):
    security = ClassSecurityInfo()
    __implements__ = (getattr(BaseExamQuestion,'__implements__',()),)


    # This name appears in the 'add' box
    archetype_name             = 'TrueFalseQuestion'

    meta_type                  = 'TrueFalseQuestion'
    portal_type                = 'TrueFalseQuestion'
    allowed_content_types      = ['TrueFalseAnswer'] + list(getattr(BaseExamQuestion, 'allowed_content_types', []))
    filter_content_types       = 1
    global_allow               = 0
    allow_discussion           = 0
    content_icon               = 'icon_question_blue.png'
    immediate_view             = 'base_view'
    default_view               = 'base_view'
    suppl_views                = ()
    typeDescription            = "TrueFalseQuestion"
    typeDescMsgId              = 'description_edit_truefalsequestion'

    schema = TrueFalseQuestion_schema

    ##code-section class-header #fill in your manual code here
    
    ##/code-section class-header


    #Methods
    #manually created methods

    def processResponse(self, REQUEST):
        ''' 
        '''
        #get an responseObject from BaseExamQuestion
        #context and question are set
        responseObj=BaseExamQuestion.processResponse(self, REQUEST)
        
        kw={} #Dict
        correctCounter=0
        answerObjects=self.objectValues(['TrueFalseAnswer'])
        
        for answer in answerObjects:
            awUId=answer.UID()
            reqKey='##'.join((self.UID(), awUId))         
            kw[awUId]=REQUEST.get(reqKey, False)
            
            #process Answer (see, if correct and increase counter if so)
            answer=self._lookupUID(awUId)
            if answer.processValue(kw[awUId]):
                correctCounter += 1
            
        #fill in actual user-input as answers
        responseObj.setResponseValues(**kw)

        #now calculate and set score
        possibleCorrect=len(answerObjects) #is not the case for i.e. maching
        
        if possibleCorrect == 0:
            score = float(0)
        else:
            if self.getStrict():
                if possibleCorrect == correctCounter:
                    score=self.getMaxScore()
                else:
                    score=0
            else:
                score=float(self.getMaxScore()) / possibleCorrect * correctCounter
            
        responseObj.setScore(score)

        examFolder=self.aq_parent
        if examFolder.getParam_storageMethod()=='eXamFolder':
            examFolder.storeResponseAttr(self.UID(), responseObj)



registerType(TrueFalseQuestion,PROJECTNAME)
# end of class TrueFalseQuestion

##code-section module-footer #fill in your manual code here
registerQuestionType(TrueFalseQuestion)
##/code-section module-footer



