# File: registry.py
"""\
registry for question types

RCS-ID $Id: registry.py,v 1.1.1.1 2006/03/05 17:27:28 nlz Exp $
"""
# Copyright (c) 2004 by eduplone Open Source Business Network EEIG, contributed
# by FH-Aargau, Switzerland
#
# Generated: Tue Dec 14 10:39:59 2004
# Generator: ArchGenXML Version 1.2 devel 3 http://sf.net/projects/archetypes/
#
# GNU General Public Licence (GPL)
#
# This program is free software; you can redistribute it and/or modify it under
# the terms of the GNU General Public License as published by the Free Software
# Foundation; either version 2 of the License, or (at your option) any later
# version.
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
# FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
# details.
# You should have received a copy of the GNU General Public License along with
# this program; if not, write to the Free Software Foundation, Inc., 59 Temple
# Place, Suite 330, Boston, MA  02111-1307  USA
#
__author__  = 'Jens Klein <jens.klein@jensquadrat.com>', 'Nils Haagen <nhaagen@philter.de>',
__docformat__ = 'plaintext'

_question_types = {}
_answer_types = {}
_additional_types = {}

from interfaces.IExamQuestion import IExamQuestion
from interfaces.IExamAnswer import IExamAnswer

def registerAdditionalType(klass):
    """ register an additional class, such as QOrderProcessor """
    if not klass.__name__ in _additional_types.keys():
        _additional_types[klass.__name__]=klass
        
def getAdditionalTypes():
    return _additional_types.copy()

def registerQuestionType(klass):
    """ register a IExamQuestion implementing class """
    if not IExamQuestion.isImplementedByInstancesOf(klass):
        raise NotImplementedError('The class %s does not implement interface IExamQuestion' % klass.__name__)
    if not klass.__name__ in _question_types.keys():
        _question_types[klass.__name__]=klass

def getQuestionTypes():
    return _question_types.copy()

def registerAnswerType(klass):
    """ register a IExamAnswer implementing class """
    if not IExamAnswer.isImplementedByInstancesOf(klass):
        raise NotImplementedError('The class %s does not implement interface IExamAnswer' % klass.__name__)
    if not klass.__name__ in _answer_types.keys():
        _answer_types[klass.__name__]=klass

def getAnswerTypes():
    return _answer_types.copy()
