# File: SimpleResponse.py
# 
# Copyright (c) 2006 by eduplone Open Source Business Network EEIG, contributed
# by FH-Aargau, Switzerland
# Generator: ArchGenXML Version 1.4.0-RC1 
#            http://plone.org/products/archgenxml
#
# GNU General Public Licence (GPL)
# 
# This program is free software; you can redistribute it and/or modify it under
# the terms of the GNU General Public License as published by the Free Software
# Foundation; either version 2 of the License, or (at your option) any later
# version.
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
# FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
# details.
# You should have received a copy of the GNU General Public License along with
# this program; if not, write to the Free Software Foundation, Inc., 59 Temple
# Place, Suite 330, Boston, MA  02111-1307  USA
#
__author__  = '''Nils Haagen <nhaagen@philter.de>, Jens Klein <jens.klein@jensquadrat.com>'''
__docformat__ = 'plaintext'


from AccessControl import ClassSecurityInfo
from Products.Archetypes.atapi import *
from Products.EduploneExam.interfaces.IExamResponse import IExamResponse


from Products.EduploneExam.config import *
##code-section module-header #fill in your manual code here

from Globals import InitializeClass
from Products.CMFCore.utils import getToolByName
from Products.Archetypes.config import UID_CATALOG
from ExtensionClass import Base

##/code-section module-header

schema=Schema((
    FloatField('userScore',
        widget=DecimalWidget(
            label='Userscore',
            label_msgid='EduploneExam_label_userScore',
            description_msgid='EduploneExam_help_userScore',
            i18n_domain='EduploneExam',
        )
    ),

),
)


##code-section after-local-schema #fill in your manual code here
##/code-section after-local-schema

SimpleResponse_schema = BaseSchema + \
    schema

##code-section after-schema #fill in your manual code here
##/code-section after-schema

class SimpleResponse(BaseContent):
    security = ClassSecurityInfo()
    __implements__ = (getattr(BaseContent,'__implements__',()),) + (IExamResponse,)


    # This name appears in the 'add' box
    archetype_name             = 'SimpleResponse'

    meta_type                  = 'SimpleResponse'
    portal_type                = 'SimpleResponse'
    allowed_content_types      = []
    filter_content_types       = 0
    global_allow               = 1
    allow_discussion           = 0
    #content_icon               = 'SimpleResponse.gif'
    immediate_view             = 'base_view'
    default_view               = 'base_view'
    suppl_views                = ()
    typeDescription            = "SimpleResponse"
    typeDescMsgId              = 'description_edit_simpleresponse'

    schema = SimpleResponse_schema

    ##code-section class-header #fill in your manual code here
    security = ClassSecurityInfo()
    security.declareObjectPublic()
    security.setDefaultAccess("allow")

    _questionTitle=''
    _questionType=''
    _questionMaxScore=0
    _questionuid=None
    _contextuid=None
    _responseValues={}
    _userScore=0
    _overrideScore=0
    _overrideComment=''
    ##/code-section class-header


    #Methods
    #methods from Interface IExamResponse

    security.declarePublic('setQuestion')
    def setQuestion(self, question):
        '''
        sets the question as a reference and buffers some important values
        '''
        self._questionuid = question.UID()
        self._questionTitle=question.Title()
        self._questionType=question.archetype_name
        self._questionMaxScore=question.getMaxScore()



    security.declarePublic('getQuestion')
    def getQuestion(self, instance):
        '''
        returns the referenced question object
        '''
        return self._lookupUID(self._questionuid, instance)



    security.declarePublic('getQuestionTitle')
    def getQuestionTitle(self):
        '''
        returns title of question
        '''
        return self._questionTitle



    security.declarePublic('getQuestionType')
    def getQuestionType(self):
        '''
        returns type of question
        '''
        return self._questionType



    security.declarePublic('setContext')
    def setContext(self,context):
        '''
        set context as a reference
        '''
        self._contextuid = context.UID()



    security.declarePublic('getContext')
    def getContext(self, instance):
        '''
        returns the context object
        '''
        return self._lookupUID(self._contextuid, instance)



    security.declarePublic('setScore')
    def setScore(self, score):
        '''
        sets the user score
        '''
        self._userScore=score



    security.declarePublic('getScore')
    def getScore(self):
        '''
        returns the user score
        '''
        #return self._userScore
        return round(self._userScore, 2)



    security.declarePublic('getMaxScore')
    def getMaxScore(self):
        '''
        returns the buffered maxscore value
        '''
        return self._questionMaxScore



    security.declarePublic('getResponseValues')
    def getResponseValues(self):
        '''
        returns a dictionary where key is the AnswerUID and value is whats a
        user said.
        '''
        return self._responseValues



    security.declarePublic('setResponseValues')
    def setResponseValues(self, **kwargs):
        '''
        kwargs is a dictionary where key is AnswerUID and value is what a
        user said.
        '''
        self._responseValues=kwargs



    security.declarePublic('__getitem__')
    def __getitem__(self, key):
        '''
        returns a specific response value
        '''
        if self._responseValues.has_key(key):
            return self._responseValues[key]
        else:
            return None


    #manually created methods

    def setOverrideScore(self, s):
        """ """
        if not s : s=0
        self._overrideScore=float(s)


    def setOverrideComment(self, c):
        """ """
        self._overrideComment=c
        

    def _lookupUID(self, uid, instance):
        tool = getToolByName(instance, UID_CATALOG)
        brains = tool(UID=uid)
        for brain in brains:
            obj = brain.getObject()
            if obj is not None:
                return obj
        else:
            return None


    def getOverrideComment(self):
        """ """
        return self._overrideComment


    def getOverrideScore(self):
        """ """
        return self._overrideScore
        

    def getRelevantScore(self):
        """ """
        if self._overrideScore > 0:
            return self._overrideScore
        else:
            return self._userScore
        


registerType(SimpleResponse,PROJECTNAME)
# end of class SimpleResponse

##code-section module-footer #fill in your manual code here
##/code-section module-footer



